package url

import (
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"
	"url_generate/internal/logic/url"
	"url_generate/internal/svc"
	"url_generate/internal/types"
)

// Retrieve Short URL
func GetOriginalURLHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.URLRequest
		if err := httpx.Parse(r, &req); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := url.NewGetOriginalURLLogic(r.Context(), svcCtx)
		resp, err := l.GetOriginalURL(&req)
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
