package url

import (
	"context"

	"url_generate/internal/svc"
	"url_generate/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type CreateShortURLLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

// Create Short URL
func NewCreateShortURLLogic(ctx context.Context, svcCtx *svc.ServiceContext) *CreateShortURLLogic {
	return &CreateShortURLLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *CreateShortURLLogic) CreateShortURL(req *types.CreateShortURLRequest) (*types.URLCodeResponse, error) {
	code, err := l.svcCtx.URLUseCase.CreateShortCode(l.ctx, req.URL)
	if err != nil {
		return nil, err
	}

	return &types.URLCodeResponse{
		Code: code,
	}, nil
}
