package url

import (
	"context"

	"url_generate/internal/svc"
	"url_generate/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type DeleteShortURLLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

// Delete Short URL
func NewDeleteShortURLLogic(ctx context.Context, svcCtx *svc.ServiceContext) *DeleteShortURLLogic {
	return &DeleteShortURLLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *DeleteShortURLLogic) DeleteShortURL(req *types.URLRequest) (*types.RespOK, error) {
	err := l.svcCtx.URLUseCase.DeleteShortCode(l.ctx, req.ShortCode)
	if err != nil {
		return nil, err
	}

	return &types.RespOK{}, nil
}
