package url

import (
	"context"

	"url_generate/internal/svc"
	"url_generate/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetOriginalURLLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

// Retrieve Short URL
func NewGetOriginalURLLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetOriginalURLLogic {
	return &GetOriginalURLLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *GetOriginalURLLogic) GetOriginalURL(req *types.URLRequest) (*types.URLResponse, error) {
	url, err := l.svcCtx.URLUseCase.GetURLByShortCode(l.ctx, req.ShortCode)
	if err != nil {
		return nil, err
	}

	return &types.URLResponse{URL: url}, nil
}
