package domain

import "strings"

type RedisKey string

const (
	URLRedisKey RedisKey = "url"
)

func (key RedisKey) ToString() string {
	return string(key)
}

func (key RedisKey) With(s ...string) RedisKey {
	parts := append([]string{string(key)}, s...)

	return RedisKey(strings.Join(parts, ":"))
}

func GetURLCodeRedisKey(code string) string {
	return URLRedisKey.With(code).ToString()
}
