package repository

import (
	"context"
	"go.mongodb.org/mongo-driver/mongo"
	"url_generate/internal/module/url/domain/entity"
)

type URLRepository interface {
	InsertMany(ctx context.Context, urls []*entity.URLTable) error
	FindOne(ctx context.Context, shortCode string) (*entity.URLTable, error)
	Delete(ctx context.Context, shortCode string) (int64, error)
	Update(ctx context.Context, shortCode string, url string) error
	EmptyCount(ctx context.Context) (int, error)
	BindOne(ctx context.Context, url string) (string, error)
	UrlIndexUP
}

type UrlIndexUP interface {
	Index20241226001UP(ctx context.Context) (*mongo.Cursor, error)
}
