package usecase

import (
	"context"
)

// URLUseCase defines the core business logic interface for managing short URLs.
type URLUseCase interface {
	// CreateShortCode creates a short code for the given URL.
	CreateShortCode(ctx context.Context, url string) (string, error)
	// GetURLByShortCode retrieves the original URL associated with a given short code.
	GetURLByShortCode(ctx context.Context, shortCode string) (string, error)
	// DeleteShortCode removes the mapping of a given short code.
	DeleteShortCode(ctx context.Context, shortCode string) error
}
